//MyArray.h   ver 1.0.0.0 
#ifndef __MYARRAY_H
#define	__MYARRAY_H

template <class dataType>
class MyArray
{
public:
	typedef		dataType&			reference;
	typedef		const dataType&     const_reference;
	typedef		dataType*			iterator;
	typedef		const dataType*     const_iterator;
	typedef		dataType*           pointer;



	//ڿ m_iSize m_iCapacityũⰡ .
	MyArray(int iSize = 0)
	{
		m_iSize = 0;
		m_iCapacity = 0;
        m_pArray = 0;

		m_iSize = Reserve(iSize);	
	}

	~MyArray()
    {
		Release();
    }

	void Release()
	{
		if(m_pArray)
		{
			delete[] m_pArray;
			m_pArray = 0;
			m_iSize = 0;
			m_iCapacity = 0;
		}
	}

	void Clear()
	{
		m_iSize = 0;
	}

	int  Reserve(int iSize)
	{
		if(iSize > 0 && m_pArray == 0)
		{
			m_pArray = new dataType[iSize];
			if(m_pArray)
			{
				m_iCapacity = iSize;
				return iSize;
			}
		}

		return 0;
	}

	void Resize(int iSize)
	{
        dataType* pNewArray = new dataType[iSize];
        if(pNewArray == 0)
            return;

        int min;
        if(iSize < m_iSize)
            min = iSize;
        else
            min = m_iSize;

        for(int index = 0; index < min; index++ )
            pNewArray[index] = m_pArray[index];

        if( m_pArray != 0 )
            delete[] m_pArray;

        m_pArray = pNewArray;
	}

	void PushBack(dataType item)
	{
		if (m_iSize < m_iCapacity)
		{
			m_pArray[m_iSize] = item;
			++m_iSize;
		}
		else
		{
			m_iCapacity = CalculateCapacity(m_iSize + 1);
			Resize(m_iCapacity);
			m_pArray[m_iSize] = item;
			m_iSize++;
		}
	}

	void PopBack()
	{
		if(m_iSize <= 0)
			return;

		m_iSize--;
	}

	void PopBack(pointer item)
	{
		if(m_iSize <= 0)
			return;

		*item = m_pArray[m_iSize - 1];
		m_iSize--;
	}

    bool Insert(int iIndex , dataType item)
    {
		// ε ߰ Ѵ.
		if(iIndex >= m_iSize)
			return  false;

		if (m_iSize >= m_iCapacity)
		{
			m_iCapacity = CalculateCapacity(m_iSize + 1);
			Resize(m_iCapacity);
		}

		m_iSize++;
        for( int i = m_iSize - 1; i > iIndex; i-- )
            m_pArray[i] = m_pArray[i - 1];

        m_pArray[iIndex] = item;
		return true;
    }

    bool Erase(int iIndex)
    {
		if(iIndex >= m_iSize)
			return false;

        for(int i = iIndex + 1; i < m_iSize; i++ )
            m_pArray[i - 1] = m_pArray[i];

		m_iSize--;
		return true;
    }

	bool Empty() const
	{	
		return (m_iSize == 0);
	}

	int  MaxSize()
	{
		return ((unsigned int(-1) / sizeof (dataType)) >> 1);
	}

	int  Capacity()
	{
		return m_iCapacity;
	}

    int  Size()
    {
        return m_iSize;
    }

	reference At(int iIndex)
	{
		if(iIndex >= m_iSize)
		{
#ifdef _SHOW_DEBUG
			OutputDebugString("Out of range error : MyArray::At()\n");
#endif
			return m_pArray[0];
		}
		return m_pArray[iIndex];
	}

    reference operator[](int iIndex)
    {
        return m_pArray[iIndex];
    }
    
    operator pointer()
    {
        return m_pArray;
    }


	// STL-style interface
    iterator	begin(void)		{ return &m_pArray[0]; }
    iterator	end(void)		{ return &m_pArray[0] + m_iSize; }

private:
	int CalculateCapacity(int iSize)
	{
		int iCapacity = m_iCapacity;
		if (iSize > m_iCapacity)
		{
			//m_iCapacity 50% ũ⸦  Ų. max_size()  uSizeŭ  Ų.
			iCapacity = ((MaxSize() - iCapacity / 2) < iCapacity) ? 0 : iCapacity + iCapacity / 2;
			if (iCapacity < iSize)
				iCapacity = iSize;
		}

		return iCapacity;
	}

private:
	dataType*		m_pArray;
	int				m_iSize;
	int				m_iCapacity;
};

#endif
